﻿var $doctype = "";
var $customCallbackMade = false;
var $documentType = "";
let documentClosed = false;
let bHasUnsavedChanges = false;
let bClosedUsingButton = false;
function b64EncodeUnicode(str)
{
    // first we use encodeURIComponent to get percent-encoded UTF-8,
    // then we convert the percent encodings into raw bytes which
    // can be fed into btoa.
    return btoa(encodeURIComponent(str).replace(/%([0-9A-F]{2})/g,
        function toSolidBytes(match, p1)
        {
            return String.fromCharCode('0x' + p1);
        }));
}
function b64DecodeUnicode(str)
{
    // Going backwards: from bytestream, to percent-encoding, to original string.
    return decodeURIComponent(atob(str).split('').map(function (c)
    {
        return '%' + ('00' + c.charCodeAt(0).toString(16)).slice(-2);
    }).join(''));
}
$(document).ready(function ()
{
    console.log("ready");
    if ($toon != undefined)
    {
        // $toon = true;
    }
    //2024-01-18 SN: # refresh for document is in edit mode
    var strFolderPath = $('#strFolderPath').val();
    var p1 = strFolderPath;
    var p = p1.replace(/\\/g, "/");
    if (p.charAt(0) == '/') {
        p = p.substr(1);
    }
    fnSendWsUpdate(p);
    sendRefreshstatusForEditor(strFolderPath);
    //2024-01-18 SN: #
   
    $(window).bind("beforeunload", function (event) {
        event.preventDefault();
        event.returnValue = false;
        var streditInfo = "";
        $customCallbackMade = true;
        if ($documentType == "RichEdit") {
            $doctype = "1";
            streditInfo = b64EncodeUnicode(RichEdit.cpCurrendDocId);            
        }
        else {
            $doctype = "2";
            streditInfo = b64EncodeUnicode(Spreadsheet.cpCurrendDocId);            
        }
        var wholeData = JSON.stringify({ 'id': streditInfo, 'removeSessionData': "false" });
        var strFolderPath = $('#strFolderPath').val();
        if (documentClosed == false) {
            fncloseEditorWindow(streditInfo, strFolderPath, bHasUnsavedChanges);
        }         
        if (bHasUnsavedChanges == true) {            
            ConfirmPopup.Show();
            
        } else {
            return;
        }
    });
});
function fnValidateEvent(s, e)
{

}
function fnBeginCallBack(s, e)
{
    console.log("In fnBeginCallBack", s, e);
    if (s.name == "Spreadsheet") {
        Spreadsheet.ShowLoadingPanel();
    }
    else {
        RichEdit.ShowLoadingPanel();
    }
}

function fnDocumentLoaded(s, e)
{
    console.log("In fnDocumentLoaded", s, e);
}


function fnDocumentChanged(s, e)
{
    console.log("In fnDocumentChanged", s, e);
    bHasUnsavedChanges = true;
}


function fnEndCallBack(s, e)
{
    console.log("In fnEndCallBack", s, e);
    if (s.name == "Spreadsheet")
    {
        Spreadsheet.HideLoadingPanel();
    }

    if (s.name == "RichEdit" && (e.command == "CUSTOMCALLBACK" || $customCallbackMade == true))
    {
        $(window).unbind("beforeunload");
        if ($toon != undefined)
        {
           // $toon = true;
        }

        $customCallbackMade = false;
        //close the window
        //window.close();
        if ($("#new_doc").val() == '1')
        {
            //
            //hide popup and redirect to 
            window.location = '/Home/Index2';
        }
        else
        {
            window.close();

        }
    }


    if (s.name == "Spreadsheet" && e.command == "CUSTOMCALLBACK")
    {
        $(window).unbind("beforeunload");
        LoadingPanel.SetText("Closing...");
        LoadingPanel.Show();
        if ($toon != undefined)
        {
            //$toon = true;
        }
        //close the window
        //window.close();
        if ($("#new_doc").val() == '1')
        {
            //
            //hide popup and redirect to 
            window.location = '/Home/Index2';
        }
        else
        {
            window.close();
            
        }
    }
}
function fnInit(s, e)
{
    console.log("In fnInit", s, e);
    s.SetFullscreenMode(true);
    //2024-01-18 SN: # refresh for document is in edit mode
    if (s.name == "RichEdit") {
        $documentType = "RichEdit"
    }
    if (s.name == "Spreadsheet") {
        $documentType = "Spreadsheet"
    }
   
    //2024-01-18 SN: # refresh for document is in edit mode
}

function fnCallbackError(s, e)
{
    console.log("in fnCallbackError", s, e);

}

function fnBeginSync(s, e)
{
    console.log("in fnBeginSync", s, e);
}
function fnEndSync(s, e)
{
    console.log("in fnEndSync", s, e);
    //RichEdit.PerformCallback({ save_document: "save_document" });
    if ($documentType == "Spreadsheet") {
        if (Spreadsheet.HasUnsavedChanges() == true) {
            bHasUnsavedChanges = true;
        }
    }
    if ($documentType == "RichEdit") {
        if (RichEdit.HasUnsavedChanges() == true) {
            bHasUnsavedChanges = true;
        }
    }
}
function OnCustomCommandExecuted(s, e)
{
    console.log("In OnCustomCommandExecuted", s, e);

    try
    {
        $doctype = "";
        if (s!=null)
        {
            if (s.name == "RichEdit")
            {
                $(window).unbind("beforeunload");
                $customCallbackMade = true;
                if (RichEdit.HasUnsavedChanges() == true)
                {
                    bClosedUsingButton = true;
                    //show popup and ask if user wants to save changes or not
                    $doctype = "1";
                    
                    ConfirmPopup.Show();
                }
                else
                {
                    RichEdit.PerformCallback({ save_document: RichEdit.cpCurrendDocId });
                    $doctype = "";
                }

                
                
            }
            if (s.name =="Spreadsheet")
            {
                if (Spreadsheet.HasUnsavedChanges()==true)
                {
                    //show popup and ask if user wants to save changes or not
                    $doctype = "2";
                    ConfirmPopup.Show();
                }
                else
                {
                    Spreadsheet.PerformCallback({ save_document: Spreadsheet.cpCurrendDocId });
                    $doctype = "";
                }
            }
        }
    } catch (e)
    {

    }
    //window.close();
}

function fnSaveChanges(s, e)
{
    console.log("in fnSaveChanges", s, e);

    if ($doctype == "1")
    {
        console.log(RichEdit.cpCurrendDocId);
        //RichEdit.commands.fileSave.execute();
        //we should send ajax call to close document
        ConfirmPopup.Hide();
        RichEdit.PerformCallback({ save_document: RichEdit.cpCurrendDocId });
    }

    if ($doctype == "2")
    {
        console.log(Spreadsheet.cpCurrendDocId);
        ConfirmPopup.Hide();
        Spreadsheet.PerformCallback({ save_document: Spreadsheet.cpCurrendDocId });
    }

    $doctype = "";
}

function fnCancelChanges(s, e)
{
 
    console.log("In fnCancelChanges", s, e);

    if ($toon != undefined)
    {
       // $toon = true;
    }
    $doctype = "";
    //window.close();
    fncloseDocument()
}

//2024-01-18 SN: # refresh for document is in edit mode


function fncloseDocument() {
    LoadingPanel.SetText("Closing...");
    LoadingPanel.Show();
    var streditInfo = "";
    if ($documentType == "RichEdit") {
        streditInfo = b64EncodeUnicode(RichEdit.cpCurrendDocId);

    }
    else {
        streditInfo = b64EncodeUnicode(Spreadsheet.cpCurrendDocId);
    }

    var strFolderPath = $('#strFolderPath').val();
    var wholeData = JSON.stringify({ 'id': streditInfo  ,'removeSessionData' :"true" });

    $.ajax({
        type: 'POST',
        url: `/Home/fnClosePDfDocument`,
        contentType: 'application/json; charset=utf-8',
        dataType: 'json',
        data: wholeData,
        success: function (data) {
            if (data.result == true) {
                resetTimeout(true);
                var p1 = strFolderPath;
                var p = p1.replace(/\\/g, "/");
                if (p.charAt(0) == '/') {
                    p = p.substr(1);
                }
                console.log("4");
                fnSendWsUpdate(p);
                documentClosed = true;
                $(window).unbind("beforeunload");
                window.close();
            }
            else {
                alert('Error fncloseDocument fnClosePDfDocument ' + data.message);

            }
        },
        //call on ajax call failure
        error: function (xhr, textStatus, error) {
            alert('Error fncloseDocument: ', xhr, textStatus, error);
        }
    });
}
//window.onbeforeunload = function (event) {
    
//    LoadingPanel.SetText("Closing...");
//    LoadingPanel.Show();
//    var streditInfo = "";
//    if ($documentType == "RichEdit") {
//        streditInfo = b64EncodeUnicode(RichEdit.cpCurrendDocId);
       
//    }
//    else{
//        streditInfo = b64EncodeUnicode(Spreadsheet.cpCurrendDocId);
//    }

//    var wholeData = JSON.stringify({ 'id': streditInfo });
   
//    if (documentClosed == false) {
//        $.ajax({
//            type: 'POST',
//            url: `/Home/fnClosePDfDocument`,
//            contentType: 'application/json; charset=utf-8',
//            dataType: 'json',
//            data: wholeData,
//            asycn: false,
//            success: function (result) {
//                $toon = true;


//            },
//            call on ajax call failure
//            error: function (xhr, textStatus, error) {
//               alert('Error: ', xhr, textStatus, error);
//            }
//        });
//        var strFolderPath = $('#strFolderPath').val();
//        var p1 = strFolderPath;
//        var p = p1.replace(/\\/g, "/");
//        if (p.charAt(0) == '/') {
//            p = p.substr(1);
//        }
//        fnSendWsUpdate(p);
//    }
//    else {
//        window.close();
//    }
    

//    return null;
//}

function fnShownPopup(s, e) {
    if (bClosedUsingButton == false) {
        //change status of file
        var streditInfo = "";
        if ($documentType == "RichEdit") {
            streditInfo = b64EncodeUnicode(RichEdit.cpCurrendDocId);            
        }
        else {
            streditInfo = b64EncodeUnicode(Spreadsheet.cpCurrendDocId);
        }
        var strFolderPath = $('#strFolderPath').val();
        console.log("1");
        var wholeData = JSON.stringify({ 'id': streditInfo });
        console.log("2");
        $.ajax({
            type: 'POST',
            url: `/Home/fnChangeDocumentSatus`,
            contentType: 'application/json; charset=utf-8',
            dataType: 'json',
            data: wholeData,
            success: function (data) {
                if (data.success == true) {

                    console.log("3");
                    try {
                        //show document is in edit mode
                        var p1 = strFolderPath;
                        var p = p1.replace(/\\/g, "/");
                        if (p.charAt(0) == '/') {
                            p = p.substr(1);
                        }
                        console.log("4");
                        fnSendWsUpdate(p);


                    } catch (e) {
                    }
                }
                else {
                    alert('Error : fnShownPopup fnChangeDocumentSatus ' + data.message);

                }
            },
            //call on ajax call failure
            error: function (xhr, textStatus, error) {
                console.log("5");
                alertModal('Error fnShownPopup: ', xhr, textStatus, error);
            }
        });
    }
}
function detectIE() {
    var ua = window.navigator.userAgent;
    var msie = ua.indexOf('MSIE ');
    if (msie > 0) {
        return true;
    }
    var trident = ua.indexOf('Trident/');
    if (trident > 0) {
        // IE 11 => return version number
        var rv = ua.indexOf('rv:');
        return true;
    }
    var edge = ua.indexOf('Edge/');
    if (edge > 0) {
        return true;
    }
    // other browser
    return false;
}
//2024-01-18


function resetTimeout(value) {
    console.log("toon value" + value);
    $toon = value;
}